<template>
  <form @submit.prevent="onSubmit">
    <template v-for="field in fields">
      <field v-if="field.type === 'submit'">
        <div class="error" v-if="error">
          {{ error }}
        </div>
        <custom-button :loading="loading" class="primary">
          {{ field.content }}
        </custom-button>
      </field>
      <field v-else>
        <span
          class="input-error"
          v-if="errors[field.name]"
          v-for="error in errors[field.name]"
        >
          {{ error }}
        </span>
        <textarea
          v-if="field.type === 'textarea'"
          :name="field.name"
          autocomplete="off"
          :placeholder="field.placeholder"
          :required="field.required"
          :minlength="field.minLength"
          >{{ field.value }}</textarea
        >
        <select
          v-else-if="field.type === 'select'"
          :name="field.name"
          autocomplete="off"
          :required="field.required"
        >
          <option
            v-for="option in field.options"
            :value="option.value"
            :disabled="option.disabled"
            :selected="field.value === option.value"
          >
            {{ option.content }}
          </option>
        </select>
        <input
          v-else
          :type="field.type"
          :name="field.name"
          autocomplete="off"
          :placeholder="field.placeholder"
          :required="field.required"
          :minlength="field.minLength"
          v-model="inputValueBinds[field.name]"
        />
      </field>
    </template>
  </form>
</template>

<script>
import Field from '@/components/Field'
import CustomButton from '@/components/Button'

import { grabValues } from '@/utils'

export default {
  name: 'Form',
  components: { Field, CustomButton },
  props: ['fields', 'handleSubmit', 'parseError'],
  data() {
    const inputFields = this.fields.filter(field => field.type === 'input')
    let binds = {}

    for (const field of inputFields) {
      binds[field.name] = field.name || ''
    }

    return {
      error: null,
      errors: {},
      loading: false,
      inputValueBinds: binds,
    }
  },
  methods: {
    async onSubmit(event) {
      this.error = null
      this.errors = {}
      this.loading = true
      const values = grabValues(event)

      try {
        await this.handleSubmit(values)
      } catch (error) {
        if (typeof error === 'string') this.error = this.parseError(error)
        else this.errors = error
      }

      this.loading = false
    },
  },
}
</script>

<style scoped>
.error {
  padding-bottom: 0.3em;
}
</style>
